=== debian/changelog ===
xxhash (0.7.3-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Repository, Repository-
    Browse.

  [ Norbert Preining ]
  * New upstream version 0.7.3
  * Install new files (pkg-config, header, new tool xxh128sum plus man)

 -- Norbert Preining <norbert@preining.info>  Fri, 13 Mar 2020 03:32:28 +0900
