=== debian/control ===
Source: xxhash
Section: utils
Priority: optional
Maintainer: Norbert Preining <norbert@preining.info>
Build-Depends: debhelper-compat (= 12), dpkg-dev (>= 1.16.2)
Standards-Version: 4.2.1
Homepage: https://cyan4973.github.io/xxHash
Vcs-Git: https://github.com/norbusan/debian-xxhash.git
Vcs-Browser: https://github.com/norbusan/debian-xxhash

Package: xxhash
Architecture: any
Depends: libxxhash0 (>= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Extremely fast hash algorithm
 xxHash is an Extremely fast Hash algorithm, running at RAM speed limits.
 It successfully completes the SMHasher test suite which evaluates collision,
 dispersion and randomness qualities of hash functions. Code is highly portable,
 and hashes are identical on all platforms (little / big endian).

Package: libxxhash0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: shared library for xxhash
 xxHash is an Extremely fast Hash algorithm, running at RAM speed limits.
 It successfully completes the SMHasher test suite which evaluates collision,
 dispersion and randomness qualities of hash functions. Code is highly portable,
 and hashes are identical on all platforms (little / big endian).
 .
 This package contains the shared library.

Package: libxxhash-dev
Architecture: any
Section: libdevel
Depends: libxxhash0 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: header files and a static library for libxxhash
 xxHash is an Extremely fast Hash algorithm, running at RAM speed limits.
 It successfully completes the SMHasher test suite which evaluates collision,
 dispersion and randomness qualities of hash functions. Code is highly portable,
 and hashes are identical on all platforms (little / big endian).
 .
 This package contains xxHash static library and header files.
