=== cmake_unofficial/CMakeLists.txt ===
--- 
+++ 
@@ -118,6 +118,7 @@
 
   install(TARGETS xxhash
     EXPORT xxHashTargets
+    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
     LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
     ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}")
   install(FILES "${XXHASH_DIR}/xxhash.h"
