=== debian/changelog ===
xxhash (0.8.0-2) unstable; urgency=medium

  * Use hardware-accelerated XXH3 computation on x86 architecture, and
    install the hardware-accelerating header file. 
    Thanks to Julian Andres Klode. (Closes: #977345)
  * Cherry-pick upstream: Fix empty version in .pc file (Closes: #979758)

 -- Norbert Preining <norbert@preining.info>  Mon, 11 Jan 2021 21:57:57 +0900

xxhash (0.8.0-1) unstable; urgency=medium

  * New upstream version 0.8.0
  * update patch
  * bump standards version, no changes necessary

 -- Norbert Preining <norbert@preining.info>  Mon, 10 Aug 2020 01:02:50 +0900

xxhash (0.7.4-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit.

  [ Norbert Preining ]
  * New upstream version 0.7.4
  * Update symbols file

 -- Norbert Preining <norbert@preining.info>  Tue, 30 Jun 2020 17:10:59 +0900

xxhash (0.7.3-2) unstable; urgency=medium

  [ Chris Lamb ]
  * Make the build reproducible (Closes: #956583)

 -- Norbert Preining <norbert@preining.info>  Mon, 13 Apr 2020 19:00:33 +0900
