=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Norbert Preining <norbert@preining.info>
 Build-Depends: debhelper-compat (= 12), dpkg-dev (>= 1.16.2)
-Standards-Version: 4.2.1
+Standards-Version: 4.5.0
 Homepage: https://cyan4973.github.io/xxHash
 Vcs-Git: https://github.com/norbusan/debian-xxhash.git
 Vcs-Browser: https://github.com/norbusan/debian-xxhash
