=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,12 @@
 
 #export DH_VERBOSE=1
 
-DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+include /usr/share/dpkg/architecture.mk
+
+ifneq (,$(filter $(DEB_HOST_ARCH_CPU),i386 amd64))
+	export DISPATCH=1
+endif
+
 %:
 	dh $@
