=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: xxhash
 Section: utils
 Priority: optional
-Maintainer: Norbert Preining <norbert@preining.info>
-Build-Depends: debhelper-compat (= 12), dpkg-dev (>= 1.16.2)
-Standards-Version: 4.5.0
+Maintainer: Josue Ortega <josue@debian.org>
+Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2)
+Standards-Version: 4.6.0
 Homepage: https://cyan4973.github.io/xxHash
-Vcs-Git: https://github.com/norbusan/debian-xxhash.git
-Vcs-Browser: https://github.com/norbusan/debian-xxhash
+Vcs-Browser: https://salsa.debian.org/debian/xxhash
+Vcs-Git: https://salsa.debian.org/debian/xxhash.git -b master
+Rules-Requires-Root: no
 
 Package: xxhash
 Architecture: any
