=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/xxhash-$1\.tar\.gz/ \
  https://github.com/Cyan4973/xxHash/releases/latest .*/v?(\d\S*)\.tar\.gz
